package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRDuty;
import cn.ibizlab.humanresource.core.humanresource.filter.HRDutySearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRDuty] 服务对象接口
 */
public interface IHRDutyService extends IService<HRDuty>{

    boolean create(HRDuty et) ;
    void createBatch(List<HRDuty> list) ;
    boolean update(HRDuty et) ;
    void updateBatch(List<HRDuty> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRDuty get(String key) ;
    HRDuty getDraft(HRDuty et) ;
    boolean checkKey(HRDuty et) ;
    boolean save(HRDuty et) ;
    void saveBatch(List<HRDuty> list) ;
    Page<HRDuty> searchDefault(HRDutySearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRDuty> getHrdutyByIds(List<String> ids) ;
    List<HRDuty> getHrdutyByEntities(List<HRDuty> entities) ;
}


